## org.apache.mahout.math.map
Class OpenDoubleObjectHashMap<T>

    java.lang.Object
      org.apache.mahout.math.PersistentObject
          org.apache.mahout.math.set.AbstractSet
              org.apache.mahout.math.map.AbstractDoubleObjectMap<T>
                  org.apache.mahout.math.map.OpenDoubleObjectHashMap<T>

All Implemented Interfaces:
  Serializable, Cloneable

    public class OpenDoubleObjectHashMap<T>

extends AbstractDoubleObjectMap<T>

See Also:
  Serialized Form

Field Summary

Fields inherited from class org.apache.mahout.math.set.AbstractSet
`DEFAULT_CAPACITY, DEFAULT_MAX_LOAD_FACTOR, DEFAULT_MIN_LOAD_FACTOR, distinct, highWaterMark, lowWaterMark, maxLoadFactor, minLoadFactor`

Constructor Summary
`OpenDoubleObjectHashMap()` Constructs an empty map with default capacity and default load factors.
`OpenDoubleObjectHashMap(int initialCapacity)` Constructs an empty map with the specified initial capacity and default load factors.
`OpenDoubleObjectHashMap(int initialCapacity, double minLoadFactor, double maxLoadFactor)` Constructs an empty map with the specified initial capacity and the specified minimum and maximum load factor.

Method Summary
`void` `clear()` Removes all (key,value) associations from the receiver.
`OpenDoubleObjectHashMap<T>` `clone()` Returns a deep copy of the receiver.
`boolean` `containsKey(double key)` Returns `true` if the receiver contains the specified key.
`boolean` `containsValue(T value)` Returns `true` if the receiver contains the specified value.
`void` `ensureCapacity(int minCapacity)` Ensures that the receiver can hold at least the specified number of associations without needing to allocate new internal memory.
`boolean` `forEachKey(DoubleProcedure procedure)` Applies a procedure to each key of the receiver, if any.
`boolean` `forEachPair(DoubleObjectProcedure<T> procedure)` Applies a procedure to each (key,value) pair of the receiver, if any.
`T` `get(double key)` Returns the value associated with the specified key.
`protected void` `getInternalFactors(int[] capacity, double[] minLoadFactor, double[] maxLoadFactor)` Access for unit tests.
`protected int` `indexOfInsertion(double key)`
`protected int` `indexOfKey(double key)`
`protected int` `indexOfValue(T value)`
`void` `keys(DoubleArrayList list)` Fills all keys contained in the receiver into the specified list.
`void` `pairsMatching(DoubleObjectProcedure<T> condition, DoubleArrayList keyList, List<T> valueList)` Fills all pairs satisfying a given condition into the specified lists.
`boolean` `put(double key, T value)` Associates the given key with the given value.
`protected void` `rehash(int newCapacity)` Rehashes the contents of the receiver into a new table with a smaller or larger capacity.
`boolean` `removeKey(double key)` Removes the given key with its associated element from the receiver, if present.
`protected void` `setUp(int initialCapacity, double minLoadFactor, double maxLoadFactor)` Initializes the receiver.
`void` `trimToSize()` Trims the capacity of the receiver to be the receiver's current size.
`void` `values(List<T> list)` Fills all values contained in the receiver into the specified list.

Methods inherited from class org.apache.mahout.math.map.AbstractDoubleObjectMap
`copy, equals, hashCode, keys, keysSortedByValue, pairsSortedByKey, pairsSortedByValue, toString, toStringByValue, values`

Methods inherited from class org.apache.mahout.math.set.AbstractSet
`chooseGrowCapacity, chooseHighWaterMark, chooseLowWaterMark, chooseMeanCapacity, chooseShrinkCapacity, equalsMindTheNull, isEmpty, nextPrime, size`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### OpenDoubleObjectHashMap

    public OpenDoubleObjectHashMap()

  Constructs an empty map with default capacity and default load factors.

### OpenDoubleObjectHashMap

    public OpenDoubleObjectHashMap(int initialCapacity)

  Constructs an empty map with the specified initial capacity and default load factors.

  Parameters:
    `initialCapacity` - the initial capacity of the map.
  Throws:
    `IllegalArgumentException` - if the initial capacity is less than zero.

### OpenDoubleObjectHashMap

    public OpenDoubleObjectHashMap(int initialCapacity,
                                   double minLoadFactor,
                                   double maxLoadFactor)

  Constructs an empty map with the specified initial capacity and the specified minimum and maximum load factor.

  Parameters:
    `initialCapacity` - the initial capacity.
    `minLoadFactor` - the minimum load factor.
    `maxLoadFactor` - the maximum load factor.
  Throws:
    `IllegalArgumentException` - if `initialCapacity < 0 || (minLoadFactor < 0.0 || minLoadFactor >= 1.0) || (maxLoadFactor <= 0.0 || maxLoadFactor >= 1.0) || (minLoadFactor >= maxLoadFactor)`.

Method Detail

### clear

    public void clear()

  Removes all (key,value) associations from the receiver. Implicitly calls `trimToSize()`.

  Specified by:
    `clear` in class `AbstractSet`

### clone

    public OpenDoubleObjectHashMap<T> clone()

  Returns a deep copy of the receiver.

  Overrides:
    `clone` in class `PersistentObject`
  Returns:
    a deep copy of the receiver.

### containsKey

    public boolean containsKey(double key)

  Returns `true` if the receiver contains the specified key.

  Overrides:
    `containsKey` in class `AbstractDoubleObjectMap<T>`
  Returns:
    `true` if the receiver contains the specified key.

### containsValue

    public boolean containsValue(T value)

  Returns `true` if the receiver contains the specified value.

  Overrides:
    `containsValue` in class `AbstractDoubleObjectMap<T>`
  Returns:
    `true` if the receiver contains the specified value.

### ensureCapacity

    public void ensureCapacity(int minCapacity)

  Ensures that the receiver can hold at least the specified number of associations without needing to allocate new internal memory. If necessary, allocates new internal memory and increases the capacity of the receiver.

  This method never need be called; it is for performance tuning only. Calling this method before `put()`ing a large number of associations boosts performance, because the receiver will grow only once instead of potentially many times and hash collisions get less probable.

  Overrides:
    `ensureCapacity` in class `AbstractSet`
  Parameters:
    `minCapacity` - the desired minimum capacity.

### forEachKey

    public boolean forEachKey(DoubleProcedure procedure)

  Applies a procedure to each key of the receiver, if any. Note: Iterates over the keys in no particular order. Subclasses can define a particular order, for example, "sorted by key". All methods which can be expressed in terms of this method (most methods can) must guarantee to use the same order defined by this method, even if it is no particular order. This is necessary so that, for example, methods `keys` and `values` will yield association pairs, not two uncorrelated lists.

  Specified by:
    `forEachKey` in class `AbstractDoubleObjectMap<T>`
  Parameters:
    `procedure` - the procedure to be applied. Stops iteration if the procedure returns `false`, otherwise continues.
  Returns:
    `false` if the procedure stopped before all keys where iterated over, `true` otherwise.

### forEachPair

    public boolean forEachPair(DoubleObjectProcedure<T> procedure)

  Applies a procedure to each (key,value) pair of the receiver, if any. Iteration order is guaranteed to be identical to the order used by method `forEachKey(DoubleProcedure)`.

  Overrides:
    `forEachPair` in class `AbstractDoubleObjectMap<T>`
  Parameters:
    `procedure` - the procedure to be applied. Stops iteration if the procedure returns `false`, otherwise continues.
  Returns:
    `false` if the procedure stopped before all keys where iterated over, `true` otherwise.

### get

    public T get(double key)

  Returns the value associated with the specified key. It is often a good idea to first check with containsKey(double) whether the given key has a value associated or not, i.e. whether there exists an association for the given key or not.

  Specified by:
    `get` in class `AbstractDoubleObjectMap<T>`
  Parameters:
    `key` - the key to be searched for.
  Returns:
    the value associated with the specified key; `null` if no such key is present.

### indexOfInsertion

    protected int indexOfInsertion(double key)

  Parameters:
    `key` - the key to be added to the receiver.
  Returns:
    the index where the key would need to be inserted, if it is not already contained. Returns -index-1 if the key is already contained at slot index. Therefore, if the returned index < 0, then it is already contained at slot -index-1. If the returned index >= 0, then it is NOT already contained and should be inserted at slot index.

### indexOfKey

    protected int indexOfKey(double key)

  Parameters:
    `key` - the key to be searched in the receiver.
  Returns:
    the index where the key is contained in the receiver, returns -1 if the key was not found.

### indexOfValue

    protected int indexOfValue(T value)

  Parameters:
    `value` - the value to be searched in the receiver.
  Returns:
    the index where the value is contained in the receiver, returns -1 if the value was not found.

### keys

    public void keys(DoubleArrayList list)

  Fills all keys contained in the receiver into the specified list. Fills the list, starting at index 0. After this call returns the specified list has a new size that equals `this.size()`. Iteration order is guaranteed to be identical to the order used by method `forEachKey(DoubleProcedure)`.

  This method can be used to iterate over the keys of the receiver.

  Overrides:
    `keys` in class `AbstractDoubleObjectMap<T>`
  Parameters:
    `list` - the list to be filled, can have any size.

### pairsMatching

    public void pairsMatching(DoubleObjectProcedure<T> condition,
                              DoubleArrayList keyList,
                              List<T> valueList)

  Fills all pairs satisfying a given condition into the specified lists. Fills into the lists, starting at index 0. After this call returns the specified lists both have a new size, the number of pairs satisfying the condition. Iteration order is guaranteed to be identical to the order used by method `forEachKey(DoubleProcedure)`.

  Example:

       DoubleObjectProcedure condition = new DoubleObjectProcedure() { // match even keys only
       public boolean apply(double key, Object value) { return key%2==0; }
       }
       keys = (8,7,6), values = (1,2,2) --> keyList = (6,8), valueList = (2,1)

  Overrides:
    `pairsMatching` in class `AbstractDoubleObjectMap<T>`
  Parameters:
    `condition` - the condition to be matched. Takes the current key as first and the current value as second argument.
    `keyList` - the list to be filled with keys, can have any size.
    `valueList` - the list to be filled with values, can have any size.

### put

    public boolean put(double key,
                       T value)

  Associates the given key with the given value. Replaces any old `(key,someOtherValue)` association, if existing.

  Specified by:
    `put` in class `AbstractDoubleObjectMap<T>`
  Parameters:
    `key` - the key the value shall be associated with.
    `value` - the value to be associated.
  Returns:
    `true` if the receiver did not already contain such a key; `false` if the receiver did already contain such a key - the new value has now replaced the formerly associated value.

### rehash

    protected void rehash(int newCapacity)

  Rehashes the contents of the receiver into a new table with a smaller or larger capacity. This method is called automatically when the number of keys in the receiver exceeds the high water mark or falls below the low water mark.

### removeKey

    public boolean removeKey(double key)

  Removes the given key with its associated element from the receiver, if present.

  Specified by:
    `removeKey` in class `AbstractDoubleObjectMap<T>`
  Parameters:
    `key` - the key to be removed from the receiver.
  Returns:
    `true` if the receiver contained the specified key, `false` otherwise.

### setUp

    protected final void setUp(int initialCapacity,
                               double minLoadFactor,
                               double maxLoadFactor)

  Initializes the receiver.

  Overrides:
    `setUp` in class `AbstractSet`
  Parameters:
    `initialCapacity` - the initial capacity of the receiver.
    `minLoadFactor` - the minLoadFactor of the receiver.
    `maxLoadFactor` - the maxLoadFactor of the receiver.
  Throws:
    `IllegalArgumentException` - if `initialCapacity < 0 || (minLoadFactor < 0.0 || minLoadFactor >= 1.0) || (maxLoadFactor <= 0.0 || maxLoadFactor >= 1.0) || (minLoadFactor >= maxLoadFactor)`.

### trimToSize

    public void trimToSize()

  Trims the capacity of the receiver to be the receiver's current size. Releases any superfluous internal memory. An application can use this operation to minimize the storage of the receiver.

  Overrides:
    `trimToSize` in class `AbstractSet`

### values

    public void values(List<T> list)

  Fills all values contained in the receiver into the specified list. Fills the list, starting at index 0. After this call returns the specified list has a new size that equals `this.size()`.

  This method can be used to iterate over the values of the receiver.

  Overrides:
    `values` in class `AbstractDoubleObjectMap<T>`
  Parameters:
    `list` - the list to be filled, can have any size.

### getInternalFactors

    protected void getInternalFactors(int[] capacity,
                                      double[] minLoadFactor,
                                      double[] maxLoadFactor)

  Access for unit tests.

  Parameters:
    `capacity` -
    `minLoadFactor` -
    `maxLoadFactor` -

Copyright © 2008–2014 The Apache Software Foundation. All rights reserved.